/*
Copyright (C) 1999/2000 Hendrik Lipka.
All rights reserved.

This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along with this
program; if not, write to the Free Software Foundation, Inc., 675 Mass Ave,
Cambridge, MA 02139, USA or see http://www.gnu.org

If you encounter problems or have a suggestion, please mail to:
q3master@hendriklipka.de
*/

package de.hendriklipka.q3master;

/**
 * Title:        Quake3Arena MasterBrowser
 * Description:
 * Copyright:    Copyright (c) 2001 by Hendrik Lipka
 * @author Hendrik Lipka
 * @version 0.1
*/

import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;

import java.io.InterruptedIOException;

import org.log4j.*;

public class RequestListener extends Thread
{
    private Category CAT=Category.getInstance(RequestListener.class.getName());
    private Category LOG_CAT=Category.getInstance("q3master.request");

    protected boolean _stop=false;
    protected int _port=-1;
    protected StatusHandler _statusHandler=null;

    public RequestListener(int port, StatusHandler handler)
    {
        _port=port;
        _statusHandler=handler;
    }

    public void stopThread()
    {
        _stop=true;
    }

    public void run()
    {
        DatagramSocket socket=null;
        try
        {
//            socket=new DatagramSocket(_port,InetAddress.getByName("127.0.0.1"));
            socket=new DatagramSocket(_port);
            socket.setSoTimeout(5000);
            while (!_stop)
            {
                try
                {
                    byte[] data=new byte[60000];
                    DatagramPacket packet=new DatagramPacket(data,data.length);
                    socket.receive(packet);
                    CAT.info("got request from "+packet.getAddress()+":"+packet.getPort());
                    byte[] result=new byte[packet.getLength()];
                    System.arraycopy(packet.getData(),0,result,0,result.length);
                    new RequestHandler(result,packet.getAddress(),packet.getPort(),socket,_statusHandler).start(); // create and start request handler thread
                }
                catch (InterruptedIOException iiex) {} // ignore - this is an expected case...
                catch (Exception e)
                {
                    e.printStackTrace();
                }
            }
            CAT.debug("finished main loop");
        }
        catch (Exception ex)
        {
            ex.printStackTrace();
        }
        finally
        {
//            if (null!=socket)
//                socket.close();
        }
    }

}